{% extends "layout.html" %}

{% block title %}
{{ gallery['title'] }} - {{ config['title'] }}
{% endblock %}

{% block css %}
{{ super() }}
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/photoswipe/4.1.3/photoswipe.min.css"
      integrity="sha512-yxWNfGm+7EK+hqP2CMJ13hsUNCQfHmOuCuLmOq2+uv/AVQtFAjlAJO8bHzpYGQnBghULqnPuY8NEr7f5exR3Qw=="
      crossorigin="anonymous"/>
<link rel="stylesheet"
      href="https://cdnjs.cloudflare.com/ajax/libs/photoswipe/4.1.3/default-skin/default-skin.min.css"
      integrity="sha512-Rck8F2HFBjAQpszOB9Qy+NVLeIy4vUOMB7xrp46edxB3KXs2RxXRguHfrJqNK+vJ+CkfvcGqAKMJTyWYBiBsGA=="
      crossorigin="anonymous"/>
<link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/unitegallery/1.7.40/css/unite-gallery.min.css"
      integrity="sha512-EViDct/SXnZMMG2ZDK7E2r3o/rDIwocOkVYpEvbMM/4Mr3on8V70n7dLcLdOrVyPuvEFyqQzya1YPNV1DFlf0g=="
      crossorigin="anonymous"/>
{% endblock %}

{% block style %}
{{ super() }}
<style>
    .gallery {
        display: flex;
        flex-wrap: wrap;
    }

    .gallery > a {
        margin: 0.25rem;
    }

    .gallery::after {
        content: '';
        flex-grow: 1000000;
    }

    .gallery > a > img {
        display: block;
        width: 100%;
    }

    .gallery-section h2 {
        text-align: center;
        margin-top: 30px;
    }

    .gallery-section p {
        width: 70%;
        margin: 0 auto 20px;
    }

    footer {
        margin-top: 30px;
    }
</style>
{% endblock %}

{% block header_title %}
{{ gallery['title'] }}
{% endblock %}

{% block header_details %}
{{ gallery['details'] }}
{% endblock %}

{% block header_cover %}
{% if gallery['cover'] %}
{{ gallery['cover'] | media('fill-in', 2000, 300) }}
{% endif %}
{% endblock %}

{% block content %}
{% macro increment(dct, key, inc=1)%}
{% if dct.update({key: dct[key] + inc}) %} {% endif %}
{% endmacro %}
{% set counter = {'index': 0} %}
{% for section in gallery['sections'] %}
<div class="container-fluid">
    <div class="row">
        <div class="col gallery-section">
            <h2>{{ section['title'] }}</h2>
            <p>{{ section['details'] }}</p>
        </div>
    </div>
    <div class="row">
        <div class="col gallery">
            {% for image in section['images'] %}
            <a href="{{ image['url'] | media('fit-in', 2048, 1080) }}"
               data-href-480p="{{ image['url'] | media('fit-in', 720, 480) }}"
               data-href-720p="{{ image['url'] | media('fit-in', 1280, 720) }}"
               data-href-1080p="{{ image['url'] | media('fit-in', 1920, 1080) }}"
               data-href-2160p="{{ image['url'] | media('fit-in', 3840, 2160) }}"
               data-href-4320p="{{ image['url'] | media('fit-in', 7680, 4320) }}"
               class="gallery-photo" data-index="{{ counter.index }}" data-type="image"
               data-gallery="0"
            >
                <img src="{{ image['url'] | media('fit-in', 2000, 156) }}" class="thumbnail"
                     alt="{{ image['caption'] }}">
            </a>
            {{ increment(counter, 'index') }}
            {% endfor %}
        </div>
    </div>
</div>
{% endfor %}
{% include "photoswipe.html" without context %}
{% endblock %}
{% block javascript %}
{{ super() }}
<script src="https://cdnjs.cloudflare.com/ajax/libs/photoswipe/4.1.3/photoswipe.min.js"
        integrity="sha512-2R4VJGamBudpzC1NTaSkusXP7QkiUYvEKhpJAxeVCqLDsgW4OqtzorZGpulE3eEA7p++U0ZYmqBwO3m+R2hRjA=="
        crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/photoswipe/4.1.3/photoswipe-ui-default.min.js"
        integrity="sha512-SxO0cwfxj/QhgX1SgpmUr0U2l5304ezGVhc0AO2YwOQ/C8O67ynyTorMKGjVv1fJnPQgjdxRz6x70MY9r0sKtQ=="
        crossorigin="anonymous"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/unitegallery/1.7.40/js/unitegallery.min.js"
        integrity="sha512-q0Tx9njjBh0TfH3nPC2HfQbLXRyq27yx22U9zdj7nwH97SfIbnvAwTqpjwowq2dDZBe2k84sx/GdEZwzHsDqUQ=="
        crossorigin="anonymous"></script>
<script>
    var slides = {}

    function createSlides() {
        $("a.gallery-photo").each(function (photo_id, photo) {
            var slide = {
                w: photo.getAttribute('data-width'),
                h: photo.getAttribute('data-height'),
                msrc: photo.getElementsByTagName('img')[0].getAttribute('src'),
                title: photo.getElementsByTagName('img')[0].getAttribute('alt'),
            };

            if (photo.getAttribute('data-type') == 'image')
                slide['src'] = photo.getAttribute('href');
            else
                slide['html'] = '<video style="margin: 0px auto; height: 100%; max-width: 100%; max-height: 100%; display: block" data-index="' + photo.getAttribute('data-index') +
                    '" controls><source src="' + photo.getAttribute('href') + '" type="video/mp4"></video>';

            var gallery_id = parseInt(photo.getAttribute('data-gallery'));
            if (!(gallery_id in slides))
                slides[gallery_id] = [];

            slides[gallery_id].push(slide);
        });
    }

    function getThumbBounds(gallery, index) {
        var thumbnail = $('div.gallery a[data-gallery="' + gallery + '"][data-index="' + index + '"]')[0];
        var pageYScroll = window.pageYOffset || document.documentElement.scrollTop;
        var rect = thumbnail.getBoundingClientRect();
        return {x: rect.left, y: rect.top + pageYScroll, w: rect.width};
    }

    function openPhotoSwipe() {
        var index = parseInt($(this).attr('data-index'))
        var gallery_id = $(this).attr('data-gallery')

        var options = {
            index: index,
            getThumbBoundsFn: function (id) {
                return getThumbBounds(gallery_id, id)
            },
            preload: [2, 5],
            zoomEl: false,
            shareEl: true,
            barsSize: {top: 0, bottom: 0},
            bgOpacity: 1,
            loop: false,
            mainClass: 'pswp--minimal--dark',
            shareButtons: [
                {id: 'download', label: 'Download image', url: '{{raw_image_url}}', download: true}
            ],
        };
        var gallery = new PhotoSwipe($('.pswp')[0], PhotoSwipeUI_Default, slides[gallery_id], options);

        gallery.listen('initialZoomOut', function () {
            if (this.currItem.html) {
                var videos = $('div.pswp__item video[data-index=' + this.getCurrentIndex() + ']')
                if (videos.length > 0)
                    videos[0].pause()
            }
        });

        gallery.listen('afterChange', function () {
            var videos = $('div.pswp__item video')
            for (var i = 0; i < videos.length; ++i)
                videos[i].pause()

            if (this.currItem.html) {
                var videos = $('div.pswp__item video[data-index=' + this.getCurrentIndex() + ']')
                if (videos.length > 0)
                    videos[0].play()
            }
        });

        gallery.listen('afterChange', function (index, item) {
            $('img.pswp__img').one('load', function () {
                img = this
                parent = $(img).parent()
                console.log(img.width, img.height, $(img).width(), $(img).height(), parent.width(), parent.height())

                // console.log(this);
                // $(this).parent().css('transform', 'translate3d(0px, 0px, 0px) scale(1)');
            }).each(function () {
                if (this.complete) {
                    $(this).trigger('load');
                }
            });
        });
        gallery.init();

        return false;
    }


    $(document).ready(function () {
        createSlides()
        $('div.gallery a').on('click', openPhotoSwipe)
        $('img.thumbnail').one('load', function () {
            $(this).parent().css('flex-grow', this.width * this.height / 100);
            $(this).after().css('flex-basis', this.width)
        }).each(function () {
            if (this.complete) {
                $(this).trigger('load');
            }
        });
    });
</script>
{% endblock %}

